// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition" by Clifford A. Shaffer, Prentice Hall, 2007.
// Source code Copyright (C) 2006 by Clifford A. Shaffer.

// Test program for the linked stack class

#include <iostream>
using namespace std;

#include "book.h"

#include "lstack.ht"

#include "StackTest.h"

// Driver class for list implementations

// Main routine for array-based list driver class
int main(int argc, char** argv) {
  // Declare some sample lists
  LStack<Int> S1;
  LStack<Int*> S2(15);
  LStack<int> S3;

  StackTest<Int>(S1);
  StackTest<int>(S3);
  return 0;
}
